<template>
    <div id="configuration" v-if="etatEdition.isConfiguration()">
        <h3>Configuration</h3>
        <form>
            <div class="uk-margin uk-flex">
                <div class="uk-width-1-2">
                    <label>Niveau</label>
                    <ListeNiveaux v-model="etatEdition.niveau" />
                </div>

                <div class="uk-width-1-2 uk-margin-small-left">
                    <label> Goban </label>
                    <select
                        class="uk-select"
                        v-model="etatEdition.tailleGoban"
                        @change="changerTailleGoban"
                    >
                        <option>19</option>
                        <option>18</option>
                        <option>17</option>
                        <option>16</option>
                        <option>15</option>
                        <option>14</option>
                        <option>13</option>
                        <option>12</option>
                        <option>11</option>
                        <option>10</option>
                        <option>9</option>
                    </select>
                </div>
            </div>
            <div class="uk-margin uk-flex">
                <div class="uk-width-1-2">
                    <label>Type de problème</label>
                    <span
                        v-if="etatEdition.typeProbleme"
                        class="uk-inline bulle-info"
                    >
                        <button type="button" uk-icon="info"></button>
                        <span uk-dropdown="mode: click">
                            {{ texteAide }}
                        </span>
                    </span>
                    <ListeTypeExercice
                        @action="changerTypeProbleme"
                        :typeProp="etatEdition.typeProbleme"
                        :affichageVide="true"
                        :disable="etatEdition.idExercice"
                    />
                </div>
                <div class="uk-width-1-2 uk-margin-small-left">
                    <label>Ordre affichage</label>
                    <input
                        class="uk-input"
                        v-model="etatEdition.ordreAffichage"
                        type="number"
                    />
                </div>
            </div>
            <div class="uk-margin">
                <label>Titre</label>
                <input
                    class="uk-input"
                    v-model="etatEdition.titre"
                    type="text"
                />
            </div>
            <div class="uk-margin uk-grid-small uk-child-width-auto uk-grid">
                <label
                    ><input
                        class="uk-checkbox"
                        type="checkbox"
                        checked
                        v-model="etatEdition.decoupageProbleme"
                    />
                    Découper le problème</label
                >
            </div>
            <div class="uk-margin">
                <input
                    class="uk-input"
                    type="text"
                    placeholder="Espace à laisser autour du problème"
                    v-if="etatEdition.decoupageProbleme"
                    v-model="etatEdition.espaceDecoupage"
                />
            </div>
        </form>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { getInstanceEtatEdition } from './EtatEdition';
import * as TypeProbleme from '@/components/constantes/TypeDeProbleme';
import ListeTypeExercice from '@/components/presentation/ListeTypeExercice.vue';
import ListeNiveaux from '@/components/presentation/ListeNiveaux.vue';

@Component({
    components: {
        ListeTypeExercice,
        ListeNiveaux
    }
})
export default class ConfigurationProbleme extends Vue {
    private etatEdition: any;
    private texteAide = '';
    private loaded = false;

    created() {
        this.etatEdition = getInstanceEtatEdition();
    }

    private changerTailleGoban() {
        this.$root.$emit(
            'changerTailleGoban',
            this.etatEdition.tailleGoban,
            null
        );
    }

    private changerTypeProbleme(type: string) {
        this.etatEdition.typeProbleme = type;
        this.modifierTexteAide();
    }

    private modifierTexteAide() {
        if (this.etatEdition.typeProbleme === TypeProbleme.LIBERTES) {
            this.texteAide =
                "Dans ce type d'exercice, il est demandé de cliquer sur les libertés des pierres noires. " +
                'Vous pouvez ajouter autant de pierres noires/blanches que vous le souhaitez, toutes collées les unes aux autres.';
        } else if (
            this.etatEdition.typeProbleme === TypeProbleme.CHOIXMULTIPLE
        ) {
            this.texteAide =
                "Dans ce type d'exercice, il est demandé de répondre à une question. " +
                'Le problème doit avoir une situation de initiale avec un commentaire qui pose cette question. ' +
                "Il faut une seule variation. Elle sera déroulée quand l'élève aura choisi la bonne réponse. " +
                "Ajoute autant de choix que vous le souhaitez, et grâce à la case à cochée 'Option valide', " +
                'définissis si cette option est juste ou non. ' +
                'Le problème doit avoir au moins un choix positif, et un choix négatif.';
        } else {
            this.texteAide =
                "Dans ce type d'exercice, l'élève aura à cliquer sur le problème pour le solutionner. " +
                'Vous devez donc faire une situation initiale, et autant de variations que vous le souhaitez. ';
        }
    }
}
</script>

<style scoped>
.message-erreur {
    color: red;
}
.bulle-info {
    vertical-align: baseline;
}
.uk-dropdown {
    min-width: 350px;
}
</style>
